# -*- coding: utf-8 -*-
"""
Copyright (c) 2016 Biuro Urządzania Lasu i Geodezji Leśnej

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), 
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE.
"""
from Mapa_PU.model.baza_danych import Baza
from Mapa_PU.model.konfiguracja import Konfiguracja
from Mapa_PU.kontroler import komunikaty
from Mapa_PU.widok.pasek_wiadomosci import PasekWiadomosc
from Mapa_PU.kontroler.excel import Excel, ExcelError
import shutil, os, datetime, codecs
from Mapa_PU.model import date_helper

#import plistlib

class Column():
    """Klasa pomocnicza przechowująca nazwę kolumny
        Spowodowane jest to tym że wielkość liter jest różna w opisie i zapytaniu
    """
    def __init__(self,name:str):
        self.name=name.replace('.','').replace(',','')
        self.standardized_name=name.replace('.','').replace(',','').replace('@','').upper()

class Sql():
    """Zapytanie sql"""
    def __init__(self,id:int,query:str):
        self.id=id
        self.query=query.replace('"','\'')

class KontrolaOpisu():
    """Pojedyńcza kontrola opisu taksacyjnego"""
    def __init__(self,id:int,nazwa:str,opis:str,dodatkowa:bool):
        self.id=id
        self.nazwa=nazwa
        self.opis=opis
        self.dodatkowa=dodatkowa
        self.queries=[]
        self.errors=[]
        
    @property
    def is_error(self):
        return False if len(self.errors)==0 else True
        
    def append(self,sql:Sql):
        """Dodaje obiekt zapytania do listy"""
        self.queries.append(sql)

class KontroleOpisuTaksacyjnego():
    """Kontrole opisów taksacyjnych zgodna z Kontrolami UPUL"""
    def __init__(self,root,konfiguracja:Konfiguracja,wersja,iface):
        self.__konfiguracja=konfiguracja
        self.__wersja=wersja
        self.__iface=iface
        self.__sciezka='%s\kontrola_opisu_taksacyjnego_%s.txt' % (self.__konfiguracja.kontrole, datetime.date.today())
        self.__root=root
        
    def blad(self,wiersz,opis:str):
        """Tworzy wiersz błędu na podstawie wyniku zapytania"""
        try:
            #1 pobranie nazw kolumn z opisu @nazwa_kolumny
            columns=[Column(name) for name in opis.split( ) if name.startswith('@')]
            #2 pobranie nazw kolumn z wiersza danych
            columns_row=[Column(name[0]) for name in wiersz.cursor_description]
            #3 pobranie indexu adres...
            idx_address=[i for i,e in enumerate(columns_row) if e.standardized_name.startswith('ADRES')]
            #4 wypelnienie danymi z bazy @nazwa_kolumny
            for column in columns:
                #idx=next(iter(filter(lambda x: x.standardized_name==column.standardized_name,columns_row)))
                idx=[i for i,e in enumerate(columns_row) if e.standardized_name==column.standardized_name]
                value=wiersz[idx[0]]
                opis=opis.replace(column.name, str(value))#str(value if value!=None else ''))
            return 'Adres:{} Opis:{}'.format(wiersz[idx_address[0]],opis) if len(idx_address)>0 else 'Opis:{}'.format(opis)
        except Exception as e:
            a=idx
            b=column
            raise e 
        
    def kontroluj(self,pasek:PasekWiadomosc,swdl=False):
        """Wykonuje kontrole opisów taksacyjnych
        :params pasek:Pasek postępu
        :params swdl:Zgoda na wybór tylko kontroli z flagą swdl
        """
        try:
            kontrole=self.__zaladuj(self.__root,swdl)
            size = len(kontrole)
            
            path='{}/tmp.mdb'.format(self.__konfiguracja.tmp)
            #1. Przekopiowanie bazydo tmp
            if not os.path.exists(self.__konfiguracja.tmp):
                os.mkdir(self.__konfiguracja.tmp)
            shutil.copy2(self.__konfiguracja.plikBazaTaksator,path)
            #2. Kontrole
            baza=Baza(path)
            baza.polaczOdbc()
            k=0
            for kontrola in kontrole:
                k+=1
                pasek.setText(kontrola.nazwa)
                pasek.setProgressValue((k / float(size))*100)
                #Wykonanie pojedyńczej kontroli
                id=kontrola.id
                opis=kontrola.opis
                count=len(kontrola.queries)
                for sql in kontrola.queries:
                    if sql.id==count:
                        tabela=baza.wykonajZapytanie(sql.query)
                        if len(tabela)>0:
                            for wiersz in tabela:
                                #Utworzenie wiersza raportu
                                kontrola.errors.append(self.blad(wiersz,opis))
                    else:
                        baza.wykonajZapytanieModyfikacja(sql.query)
                     
            exc=None    
            return kontrole            
        except Exception as e:
            exc=e
        finally:
            if baza!=None:
                baza.zamknijPolaczenie()
            #3. Usunięcie bazy z tmp
            #os.remove(path)
            #4 Usunięcie katalogu Tmp
            #os.rmdir(self.__konfiguracja.tmp)
            shutil.rmtree(self.__konfiguracja.tmp)
            if exc is not None:
                raise exc
            
    def start(self):
        """Wykonuje kontrole i kończy raportem"""
        try:
            #heading='Kontrole opisu taksacyjnego\nWersja programu Mapa PU {}\nRaport zawiera wyniki kontroli obligatoryjnych oraz kontroli pomocniczych.\n'.format(self.__wersja)
            heading=('Kontrole opisu taksacyjnego','Wersja programu Mapa PU {}, {}'.format(self.__wersja,date_helper.curentDate()),'Raport zawiera wyniki kontroli obligatoryjnych oraz kontroli pomocniczych.')
            pasek=PasekWiadomosc(self.__iface,u'Kontrola opisu taksacyjnego')
            pasek.pasekPostepu()
            
            
            errors=self.kontroluj(pasek)
            filename_xls='%s\kontrola_opisu_taksacyjnego_%s.xlsx' % (self.__konfiguracja.kontrole, datetime.date.today())
            self.zapiszWyniki(errors,heading,filename_xls)
            ret = komunikaty.pytanie_zamknij_pokaz_raport_txt_xls(u'Zakończenie kontroli ', (u"Zakończono kontrolę opisu taksacyjnego.  Szczegóły zostały zapisane do pliku raportu \n '%s'" % '{}\n{}'.format(self.__sciezka,filename_xls)))
            
            if ret == 1 :
                os.startfile(self.__sciezka)
            if ret==2:
                os.startfile(filename_xls)
            
        except Exception as e:
            raise e
            
    def __zaladuj(self,root,swdl:bool)->[]:
        """Pobranie danych z bazy
        :params root:Katalog aplikacji
        :params swdl:Zgoda na wybranie tylko zapytań swdl
        :return dane
        """
        lista=[]
        try:
            if swdl==False:
                sql="SELECT grupy_kontroli.id, kontrole.id, kwerendy_kontroli.kolejnoscwykonania, kontrole.nazwa, kwerendy_kontroli.nazwa, kwerendy_kontroli.sql_access, kontrole.opisbledu, kontrole.dodatkowa FROM (grupy_kontroli INNER JOIN kontrole ON grupy_kontroli.id = kontrole.idgrupykontroli) INNER JOIN kwerendy_kontroli ON kontrole.id = kwerendy_kontroli.idkontrole WHERE (((kwerendy_kontroli.sql_access) Is Not Null) AND ((kontrole.aktywna)=True)) ORDER BY grupy_kontroli.id, kontrole.id, kwerendy_kontroli.id, grupy_kontroli.kolejnoscwykonania, kontrole.kolejnoscwykonania, kwerendy_kontroli.kolejnoscwykonania;"
            else:
                sql="SELECT grupy_kontroli.id, kontrole.id, kwerendy_kontroli.kolejnoscwykonania, kontrole.nazwa, kwerendy_kontroli.nazwa, kwerendy_kontroli.sql_access, kontrole.opisbledu, kontrole.dodatkowa FROM (grupy_kontroli INNER JOIN kontrole ON grupy_kontroli.id = kontrole.idgrupykontroli) INNER JOIN kwerendy_kontroli ON kontrole.id = kwerendy_kontroli.idkontrole WHERE (((kwerendy_kontroli.sql_access) Is Not Null) AND ((kontrole.aktywna)=True) AND ((kontrole.swdl)=True)) ORDER BY grupy_kontroli.id, kontrole.id, kwerendy_kontroli.id, grupy_kontroli.kolejnoscwykonania, kontrole.kolejnoscwykonania, kwerendy_kontroli.kolejnoscwykonania;"
                        
            baza=Baza(u'{}/szablony/baza_kontroli_upul.mdb'.format(root))
            baza.polaczOdbc()
            tabela=baza.wykonajZapytanie(sql)
            baza.zamknijPolaczenie()
            
            for wiersz in tabela:
                kontrola=next(filter(lambda x:x.id==wiersz[1],lista),None)
                sql=Sql(wiersz.kolejnoscwykonania,wiersz.sql_access)
                if kontrola==None:
                    kontrola=KontrolaOpisu(wiersz[1],wiersz[3],wiersz[6],wiersz[7])
                    lista.append(kontrola)
                kontrola.append(sql)    
            
        except Exception as e:
            raise e
        finally:
            return lista
    
    def zapiszWyniki(self,wyniki:[],heading:(),filename_xls:str):
        """Zapisuje wyniki kontroli do pliku
        :param wyniki:Wyniki kontroli
        :parms heading:Nagłówek pliku kontroli
        """
        try:
            plik=codecs.open(self.__sciezka,'w',encoding="utf-8")
            
            #plik.write('Kontrole opisu taksacyjnego\nWersja programu Mapa PU {}\nRaport zawiera wyniki kontroli obligatoryjnych oraz kontroli pomocniczych.\n'.format(self.__wersja))
            plik.write('\n'.join(heading)+'\n')
            kontrole_obligatoryjne=[kontrola for kontrola in wyniki if kontrola.dodatkowa==False]
            self.wpiszWynik(kontrole_obligatoryjne, plik,'OBLIGATORYJNE')
            kontrole_pomocnicze=[kontrola for kontrola in wyniki if kontrola.dodatkowa==True]
            self.wpiszWynik(kontrole_pomocnicze, plik,'POMOCNICZE')
            
            #Zapis do pliku Excell
            excel=Excel()
            #lst=[ExcelError(wynik.opis) for wynik in wyniki if len(wynik.errors)>0]
            lst=[]
            for wynik in wyniki:
                for error in wynik.errors:
                    lst.append(ExcelError(wynik.nazwa,error,'OBLIGATORYJNE' if wynik.dodatkowa==False else 'POMOCNICZE'))
            excel.save_to_excell(lst, self.__root, filename_xls,heading)    
 
        except Exception as e:
            raise e
        finally:
            plik.close()
            
    def wpiszWynik(self,wyniki:[],plik,typ:str):
        """Wpisuje wyniki do pliku
        :params wyniki: lista wyników
        :params plik: Plik do wpisywania
        :params typ: Rodzaj kontroli: obligatoryjne, pomocnicze
        """
        try:
            if len(wyniki)==0:
                return
            nowaLinia=u'\r\n'
            lp='==========================================================================='
            l='---------------------------------------------------------------------------'
            plik.write(lp+nowaLinia)
            plik.write('KONTROLE {}{}'.format(typ,nowaLinia))
            plik.write(lp+nowaLinia)
            for kontrola in wyniki:
                    plik.write(lp+nowaLinia)
                    plik.write('{}'.format(kontrola.nazwa))
                    plik.write(l+nowaLinia)
                    plik.write('Wynik kontroli - %s' % (u'OK' if len(kontrola.errors)==0 else u'Stwierdzono błędy') +nowaLinia)
                    plik.write(l+nowaLinia)
                  
                    #===================================================================
                    for blad in kontrola.errors:
                        plik.write(u'{}{}'.format(blad,nowaLinia))
                    #===================================================================
                    plik.write(l+nowaLinia)
        except Exception as e:
            raise e